<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_software".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnSoftware".
 *
 * Columns in table "cpn_software" available as properties of the model,
 * followed by relations of table "cpn_software" available as properties of the model.
 *
 * @property integer $id
 * @property string $guid
 * @property integer $parent_id
 * @property string $file_name
 * @property string $name
 * @property string $installation_folder
 * @property string $pre_installation_exe
 * @property integer $delete_pre_after_install
 * @property string $post_installation_exe
 * @property integer $delete_post_after_install
 * @property string $pre_uninstallation_exe
 * @property string $post_uninstallation_exe
 * @property string $payload_path
 * @property string $checksum
 * @property integer $user_interface_flag
 * @property integer $enabled_flag
 * @property integer $del_flag
 * @property integer $required_flag
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property Account $addedByAccount
 * @property CpnSoftwareInstallation[] $cpnSoftwareInstallations
 * @property CpnSoftwareService[] $cpnSoftwareServices
 * @property CpnSoftwareVersion[] $cpnSoftwareVersions
 */
abstract class BaseCpnSoftware extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_software';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnSoftware|CpnSoftwares', $n);
    }

    public static function representingColumn()
    {
        return 'guid';
    }

    public function rules()
    {
        return array(
            array('guid, name, installation_folder, delete_pre_after_install, delete_post_after_install, user_interface_flag, required_flag, added_by_account_id', 'required'),
            array('parent_id, delete_pre_after_install, delete_post_after_install, user_interface_flag, enabled_flag, del_flag, required_flag, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('guid, payload_path', 'length', 'max' => 255),
            array('file_name, name, pre_installation_exe, post_installation_exe, pre_uninstallation_exe, post_uninstallation_exe, checksum', 'length', 'max' => 100),
            array('installation_folder', 'length', 'max' => 500),
            array('date_added, date_updated', 'safe'),
            array('parent_id, file_name, pre_installation_exe, post_installation_exe, pre_uninstallation_exe, post_uninstallation_exe, payload_path, checksum, enabled_flag, del_flag, date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, guid, parent_id, file_name, name, installation_folder, pre_installation_exe, delete_pre_after_install, post_installation_exe, delete_post_after_install, pre_uninstallation_exe, post_uninstallation_exe, payload_path, checksum, user_interface_flag, enabled_flag, del_flag, required_flag, date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnSoftwareInstallations' => array(self::HAS_MANY, 'CpnSoftwareInstallation', 'cpn_software_id'),
            'cpnSoftwareServices' => array(self::HAS_MANY, 'CpnSoftwareService', 'cpn_software_id'),
            'cpnSoftwareVersions' => array(self::HAS_MANY, 'CpnSoftwareVersion', 'cpn_software_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'guid' => Yii::t('app', 'Guid'),
            'parent_id' => Yii::t('app', 'Parent'),
            'file_name' => Yii::t('app', 'File Name'),
            'name' => Yii::t('app', 'Name'),
            'installation_folder' => Yii::t('app', 'Installation Folder'),
            'pre_installation_exe' => Yii::t('app', 'Pre Installation Exe'),
            'delete_pre_after_install' => Yii::t('app', 'Delete Pre After Install'),
            'post_installation_exe' => Yii::t('app', 'Post Installation Exe'),
            'delete_post_after_install' => Yii::t('app', 'Delete Post After Install'),
            'pre_uninstallation_exe' => Yii::t('app', 'Pre Uninstallation Exe'),
            'post_uninstallation_exe' => Yii::t('app', 'Post Uninstallation Exe'),
            'payload_path' => Yii::t('app', 'Payload Path'),
            'checksum' => Yii::t('app', 'Checksum'),
            'user_interface_flag' => Yii::t('app', 'User Interface Flag'),
            'enabled_flag' => Yii::t('app', 'Enabled Flag'),
            'del_flag' => Yii::t('app', 'Del Flag'),
            'required_flag' => Yii::t('app', 'Required Flag'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'addedByAccount' => null,
            'cpnSoftwareInstallations' => null,
            'cpnSoftwareServices' => null,
            'cpnSoftwareVersions' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('parent_id', $this->parent_id);
        $criteria->compare('file_name', $this->file_name, true);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('installation_folder', $this->installation_folder, true);
        $criteria->compare('pre_installation_exe', $this->pre_installation_exe, true);
        $criteria->compare('delete_pre_after_install', $this->delete_pre_after_install);
        $criteria->compare('post_installation_exe', $this->post_installation_exe, true);
        $criteria->compare('delete_post_after_install', $this->delete_post_after_install);
        $criteria->compare('pre_uninstallation_exe', $this->pre_uninstallation_exe, true);
        $criteria->compare('post_uninstallation_exe', $this->post_uninstallation_exe, true);
        $criteria->compare('payload_path', $this->payload_path, true);
        $criteria->compare('checksum', $this->checksum, true);
        $criteria->compare('user_interface_flag', $this->user_interface_flag);
        $criteria->compare('enabled_flag', $this->enabled_flag);
        $criteria->compare('del_flag', $this->del_flag);
        $criteria->compare('required_flag', $this->required_flag);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
